#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define MAXLINES 200

char amsg[] = "Easy Text Formatter for Books v1.20 (C) X-2000 V.Lidovski";
long TotalLines = 0;
char QMSpaces = 5;
long FirstLineBegin = 1;
int DSheetNumber = 1;
int PageWidth = 0;
char CurrentSide = 0;
char Spaces[31] = "";
char spc[256] = "";

typedef char PageBuffer[MAXLINES+1][128]; /* Line #0 isn't used */

PageBuffer *PageBufferBegin, *PageBufferEnd;
char LineBuffer[256], **gargv;
long CurrentLine, FirstLineEnd, StartPos, l;
int TotalPages, TP2, TotalDSheets;
unsigned char EndModus, LinesPerPage, DSheetsPerFile;
FILE *f, *fo;
int i, gargc;

void Seek0() {
  rewind(f);
  CurrentLine = 1;
}

void SeekLine(long n) {
  if (n > TotalLines) 
    return;
  if (n < CurrentLine)
    Seek0();
  while (CurrentLine < n) {
    fgets(LineBuffer, 256, f);
    CurrentLine++;
  }
}

void Init() {
  char *pp;
  fprintf(stderr, "%s\n", amsg);
  if (gargc < 4 || gargc > 5) {
    l1:fprintf(stderr, 
       "USAGE: etfb <mode> <text> <lines per page> [<gap length (default=5)>\
]\n  e.g. etfb 1 my.txt 62 3\n");
    exit(1);
  }
  l = strtol(gargv[1], &pp, 10);
  if (*pp != '\0' || l > 255 || l < 0) 
    goto l1;
  DSheetsPerFile = l;
  LinesPerPage = strtol(gargv[3], &pp, 10);
  if (*pp != '\0' || LinesPerPage < 7 || LinesPerPage > MAXLINES) 
    goto l1;
  if (gargc == 5) {
    QMSpaces = strtol(gargv[4], &pp, 10);
    if (*pp != '\0' || QMSpaces > 31)
      goto l1;
  }
  if ((f = fopen(gargv[2], "r+")) == 0) {
    fprintf(stderr, "%s%s\n", gargv[2], " not found");
    exit(2);
  }
  while (strlen(Spaces) < QMSpaces)
    strcat(Spaces, " ");
  do {
    fgets(LineBuffer, 256, f);
    if (strlen(LineBuffer) > PageWidth)
      PageWidth = strlen(LineBuffer);
    ++TotalLines;
  } while (!feof(f));
  for (i = 0; i < PageWidth; i++)
    strcat(spc, " ");
  Seek0();
  TotalPages = (TotalLines - 1)/LinesPerPage + 1;
  TP2 = TotalPages;
  TotalDSheets = (TotalPages - 1)/4 + 1;
  EndModus = TotalPages % 4;
  FirstLineEnd = (TotalPages - 1)*LinesPerPage + 1;
  StartPos = 0;
  PageBufferBegin = new PageBuffer[201];
  PageBufferEnd = new PageBuffer[201];
}  

void finish() {
  fclose(f);
}

void SetVars() {
  if (DSheetsPerFile > 0) {
    TotalPages = DSheetsPerFile*4;
    if (TP2 >= TotalPages)
      TP2 -= TotalPages;
    else {
      TotalPages = TP2;
      TP2 = 0;
    }
    EndModus = TotalPages % 4;
    FirstLineEnd = StartPos + (TotalPages - 1)*LinesPerPage + 1;
    FirstLineBegin = StartPos + 1;
    StartPos += TotalPages*LinesPerPage;
  }
}

void ReadBufferBegin() {
  i = 0;
  SeekLine(FirstLineBegin);
  do {
    ++i;
    if (CurrentLine < TotalLines) {
      fgets(LineBuffer, 256, f);
      LineBuffer[strlen(LineBuffer) - 1] = '\0'; 
    } else
      strcpy(LineBuffer, spc);
    ++CurrentLine;
    if (CurrentSide)
      while (strlen(LineBuffer) < PageWidth)
        strcat(LineBuffer, " ");
    strcpy((*PageBufferBegin)[i], LineBuffer);
  } while (i != LinesPerPage);
  FirstLineBegin += LinesPerPage;
}

void ReadBufferEnd() {
  i = 0;
  if (EndModus == 0) 
    SeekLine(FirstLineEnd);
  do {
    ++i;
    if (feof(f) || EndModus > 0)
        LineBuffer[0] = '\0';
    else {
      if (CurrentLine < TotalLines) {
        fgets(LineBuffer, 256, f);
        LineBuffer[strlen(LineBuffer) - 1] = '\0'; 
      } else 
        strcpy(LineBuffer, spc);
      ++CurrentLine;
    }  
    if (!CurrentSide)
      while (strlen(LineBuffer) < PageWidth)
        strcat(LineBuffer, " ");
    strcpy((*PageBufferEnd)[i], LineBuffer);
  } while (i != LinesPerPage);
  if (EndModus == 0) 
    FirstLineEnd -= LinesPerPage;
  if (EndModus > 0)
    if (EndModus == 3)
      EndModus = 0;
    else
      ++EndModus;
}

void PrintSheet() {
  char *s1, *s2;
  if (CurrentSide)
    sprintf(LineBuffer, "%d", 2*DSheetNumber);
  else
    sprintf(LineBuffer, "%d", 2*DSheetNumber - 1);
  fo = fopen(LineBuffer, "w");
  if (CurrentSide)
    ++DSheetNumber;
  CurrentSide = !CurrentSide;
  for (i = 1; i <= LinesPerPage; ++i) {
    if (CurrentSide) {
      s1 = (*PageBufferEnd)[i];
      s2 = (*PageBufferBegin)[i];
    } else {
      s1 = (*PageBufferBegin)[i];
      s2 = (*PageBufferEnd)[i];
    } 
    fprintf(fo, "%s%s%s\n", s1, Spaces, s2);
  }
  fclose(fo);
}

void mainp() {
  do {
    SetVars();
    do {
      ReadBufferBegin();
      ReadBufferEnd();
      PrintSheet();
    } while (FirstLineBegin <= FirstLineEnd);
  } while (TP2 != 0 && DSheetsPerFile != 0);
}

main(int argc, char *argv[]) {
  gargc = argc;
  gargv = argv;
  Init();
  mainp();
  finish();
}
